/*
			Created by: Cassandra McWade 2013
			Website: http://cassandramcwade.com
			Email: cas.TD@cassandramcwade.com
			For General Use

:Title:
Miscellaneous Rigging Tools v 1.2

:Purpose:
Expedite the process of rigging characters by having all my day-to-day tools in one central location

:Bugs:
26/03/2013--Renamer Tool

:History:
26/01/2013- Began project
2/7/2013- Work day #2

:To Do:
*Make tool only run one struct at a time, prevent variable overwiritng
*Make abbreviation to write structs so all tools are made the same
IK/FK Blend arms
Twist Bones
Include Renaming FN
Auto FK Rigging
Stretchy IK Bones
Determine left, right,center then add colour
Make option to show each tool's header


*/
struct autoFKS
(
	miscSelectionAR=#(),
	
	fn appendFN=
		(
			for x in selection do
				(
					append miscSelectionAR x
				)
		),
	
	fn autoFK=
	(
		rollout autoFKR "Automatic FK Rigging"
		(
			spinner radiusSP "Radius:" width:80 type:#integer range:[2,10,0] across:2
			spinner sidesSP "Sides:" width:80 type:#integer range:[3,10,0] 
			spinner thicknessSP "Thickness:" width:80  across:2 range:[1,10,0] 
			checkbox displayCB "Display Render Mesh:" checked:true
			
			button autoFKBT "Create FK chain"
			on autoFKBT pressed do
			(
				for i= 1 to selection.count do
				(
					pt= point box:true cross:true axisTripod:false centerMarker:false Size:1
					pt.transform= selection[i].transform--align to bone
					
					if selection[i].parent!=undefined do--sees if arent exists, then link point helper to it
					(
						pt.parent=selection[i].parent
					)
					
					cnt=circle()
					cnt.radius=radiusSP.value 
					cnt.sides=sidesSP.value 
					cnt.thickness=thicknessSP.value 
					cnt.displayrendermesh=displayCB.state
					
-- 					cnt=circle radius:10 --sides:sidesSP.value thickness:thicknessSP.value displayrendermesh:displayCB.state
					cnt.transform=pt.transform--aligns control to point
					cnt.parent=pt--inks circle to point
					
					xf=xform()--creates xform
					addModifier cnt xf--adds to controller
					xf.gizmo.rotation.Y_Rotation=90 --gets orientation of gizmo and sets Y axis to 90
					convertToSplineShape cnt--collpases to stack onto the controller
					
					selection[i].parent=cnt
				)

			)
		)
		
	),
	
	autoOrientConR=
	(
		rollout autoOrientConR "Automatic Orientation Constraints (Spine)"
		(
			label autoOrientLB "Please ensure your entire bone chain is selected prior to pressing the button" style_sunkenedge:true width:150 height:50 across:2 align:#left
			button autoOrientBT "Automatic Orientation" align:#centre
			
			on autoOrientBT pressed do
			(
				boneAr = selection as array 
				BasePT = point()
				BasePT.box = true
				BasePT.wirecolor = yellow
				BasePT.size = boneAr[1].width*2.5
				BasePT.transform = boneAr[1].transform
				BasePT.parent = boneAr[1].parent

				boneAr[1].parent = BasePT
				baseObj = BasePT

				VAL = boneAr[boneAr.count].width
						
				shp = splineShape() 
				select shp 
				spln = addNewSpline shp
				addKnot shp spln  #bezierCorner #curve [VAL,0,0] [VAL,-VAL/2,0] [VAL,VAL/2,0]
				addKnot shp spln  #bezierCorner #curve [0,VAL,0] [VAL/2,VAL,0] [-VAL/2,VAL,0]
				addKnot shp spln  #bezierCorner #curve [-VAL,0,0] [-VAL,VAL/2,0] [-VAL,-VAL/2,0]
				addKnot shp spln  #bezierCorner #curve [0,-VAL,0] [-VAL/2,-VAL,0] [VAL/2,-VAL,0]
				close shp spln
				spln = addNewSpline shp
				addKnot shp spln  #bezierCorner #curve [-0,-0,-VAL] [-0,-VAL/2,-VAL] [-0,VAL/2,-VAL]
				addKnot shp spln  #bezierCorner #curve [-0,VAL,0] [-0,VAL,-VAL/2] [-0,VAL,VAL/2]
				addKnot shp spln  #bezierCorner #curve [-0,0,VAL] [-0,VAL/2,VAL] [-0,-VAL/2,VAL]
				addKnot shp spln  #bezierCorner #curve [-0,-VAL,0] [-0,-VAL,VAL/2] [-0,-VAL,-VAL/2]
				close shp spln
				spln = addNewSpline shp
				addKnot shp spln  #bezierCorner #curve [VAL,-0,0] [VAL,-0,-VAL/2] [VAL,-0,VAL/2]
				addKnot shp spln  #bezierCorner #curve [-0,-0,VAL] [VAL/2,-0,VAL] [-VAL/2,-0,VAL]
				addKnot shp spln  #bezierCorner #curve [-VAL,-0,0] [-VAL,-0,VAL/2] [-VAL,-0,-VAL/2]
				addKnot shp spln  #bezierCorner #curve [-0,-0,-VAL] [-VAL/2,-0,-VAL] [VAL/2,-0,-VAL]
				close shp spln
				shp.thickness=.2 
				shp.sides=4 
				shp.steps=3 
				shp.displayRenderMesh=false
				shp.name=(uniqueName "CNT") 

				shp.wireColor = yellow

				converttosplineshape shp 
				updateShape shp 

				RotateObj = Shp
				Shp.transform = boneAr[boneAr.count].transform
				Shp.parent = baseObj


				for x = 1 to (boneAr.count)-1 do
				(
					boneAr[x].rotation.controller = Orientation_Constraint()
					
					BoneCount = (boneAr.count-1)
					BaseWeight = 100/BoneCount
					
					boneAr[x].rotation.controller.appendTarget baseObj (100-BaseWeight*x)
					boneAr[x].rotation.controller.appendTarget RotateObj (BaseWeight*x)
					
				)
			)
		)
	),
	
	fn unifyConObjs=
	(
		rollout unifyConObjsR "Unify Control Objects"
		(
			spinner unifySidesSP "Sides:" width:80 type:#integer range:[3,10,0] across:2
			spinner unifyStepsSP "Radius:" width:80 type:#integer range:[0,10,0] 
			spinner unifyThicknessSP "Thickness:" width:80  across:2 range:[0,30,0] 
			checkbox unifyDisplayCB "Display Render Mesh:" checked:true
			button unifyConObjsBT "Commit"
			
			on unifyConObjsBT pressed do
			(
				for x in selection do
				(
					x.render_sides= unifysidesSP.value
					x.steps= unifystepsSP.value
					x.thickness= unifyThicknessSP.value
					x.displayrendermesh=unifyDisplayCB.state
				)
			)
		)
	),
	
	------------/*RECOLOUR BY X AXIS*/--------------
	fn reColourFN=
	(
		rollout reColourR "Recolour via X Axis"
		(
			colorpicker leftCP "Left Colour:" color:[8,44,14] across:3 align:#left  --red
			colorpicker cenCP "Center Colour" color:[10,6,80] align:#center --blue
			colorpicker rightCP "Right Colour:" color:[84,7,7]  align:#right--green
			button reColourBT "Recolour"
			
			on reColourBT pressed do
			(
				autoFKS.appendFN()
				for c in autoFKS.miscSelectionAR do
				(
					if (c.pos.x > 0) then
					(
						c.wirecolor= rightCP.color
					)else(
							if (c.pos.x < 0) then
							(
								c.wirecolor= leftCP.color
							)
						)
							if (c.pos.x == 0) do
							(
								c.wirecolor= cenCP.color
							)
				)		
			)
		)
	),
	
	fn getRollouts=#(autoFK(), autoOrientConR, unifyConObjs(), reColourFN())		
)
autoFKS=autoFKS()
