/*
**************
			Created by: Cassandra McWade 2013
			Website: http://cassandramcwade.com
			Email: cas.TD@cassandramcwade.com
			For General Use

:Title:
Self-Made Selection Groups v1.4

:Purpose:
Expedite the pipeline by providing the ability to make your own selection groups for face controls, body controls, renaming, and so on

:Bugs:
09/04/2013- Began conversion from standalone script to be a part of the toolset

:History:
09/04/2013- Day 1 of work

:Include:
All functionality of previous script, paying attention to use of white space, listener and making clean code

:To Do:
Above
Set background initial FLP colour to match max rollout ---DONE
Get buttons to adopt the objects wirecolor
Add second grouping creation
Add up to 4 grouping creation
Add button to add as many groups as necessary?????
Select nodes from UI ---DONE
Separate selections and groups into two separate rollouts

**************


*/

struct selectionGroups
(
	fn selectionGroupsFN=
	(
		rollout selectionGroupsR "Self-Made Selection Groups v1.4"
		(
			local colClass=dotNetClass "System.Drawing.Color"
			local bgCol=(colorMan.getColor #background)*255
			
-- 			subRollout selectionsSGR "Quick Selections" width:(selectionGroupsR.width/2) align:#right across:2
-- 			subRollout groupsSGR "User Defined Groups" width:(selectionGroupsR.width/2) align:#left
			button flagForSelectionBT "Flag for Selection" Across:2 width:(selectionGroupsR.width/2-15)
			button clearFlagBT "Clear Flag" width:(selectionGroupsR.width/2-15)
			dotNetControl groupingDisplayFLP "system.Windows.Forms.FlowLayoutPanel" height:400 --flow layout panel (FLP)
			
			fn initFLP=
			(
				groupingDisplayFLP.backColor= colClass.fromaRGB bgCol.x bgCol.x bgCol.x
				groupingDisplayFLP.autoScroll=true
			)
			
			fn mouseDownBT sender arg=
			(
				select (getNodeByName sender.text)
			)
			
			fn buildFLP=
			(
				groupingDisplayFLP.controls.clear()
				for o in objects do
				(
					makeButton=getUserProp o "makeButton"
					if makebutton==true do
					(
						createdBT= dotNetObject "System.Windows.Forms.Button" 
						createdBT.width= groupingDisplayFLP.width-50
						c= o.wirecolor
						createdBT.backColor= colClass.fromaRGB c.r c.g c.b
						createdBT.text= o.name
						createdBT.tag= dotNetMXSValue x
						
						dotNet.addEventHandler createdBT "Mousedown" mouseDownBT 
						dotNet.setLifeTimeControl createdBT #dotNet
						
						groupingDisplayFLP.controls.add createdBT
					)	
				)	
			)
			
			on flagForSelectionBT pressed do
			(
				for x in selection do
				(
					setUserProp x "makeButton" true
				)
				buildFLP()
			)
			
			on clearFlagBT pressed do
			(
				for x in selection do
				(
					setUserProp x "makeButton" false
				)
				buildFLP()
			)
			
			on groupingDisplayFLP mouseDown sender arg do
			(
				
			)
			
			on selectionGroupsR open do
			(
				initFLP()
				buildFLP()
			)
		)
	),
	
	fn getRollouts=#(selectionGroupsFN())--getRollouts needs to be ther for every tool we write for path. OTHERWISE WONT WOR
)
selectionGroups=selectionGroups()